/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#include "CommunicationChannel.hpp"

#include "nmm/nmm_prefix.hpp"

namespace NMM {
  
  // XXX: fw: TODO?
//   void CommunicationChannel::finishStrategyList(TSAddress::BindingType binding_type) {
//     /* Determine default strategy */
//     string default_strategy(SConnectionManager::getInstance().getDefaultStrategy(getTypeInfo(), binding_type));
  
//     /* Check if default strategy is in the list */
//     list<string>::iterator found(find(getStrategyList().begin(), getStrategyList().end(), default_strategy));
//     if (found != getStrategyList().end()) {
//       /* Move default strategy to the beginning of the list */
//       getStrategyList().erase(found);
//       getStrategyList().push_front(default_strategy);
//     }
//   }
  
  TypeInfo CommunicationChannel::getStaticTypeInfo() {
    return TypeInfo("CommunicationChannel", "NMM");
  }
  
}

#include "nmm/nmm_suffix.hpp"
