/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     POINTER = 258,
     REFERENCE = 259,
     EQUALS = 260,
     ENUM = 261,
     UNSIGNED = 262,
     SIGNED = 263,
     COMMENT = 264,
     INCLUDE = 265,
     FLOATNUMBER = 266,
     NUMBER = 267,
     NUMBERWORD = 268,
     WORD = 269,
     STRING = 270,
     OR = 271,
     OTEMPLATE = 272,
     CTEMPLATE = 273,
     MODULE = 274,
     INTERFACE = 275,
     REQUIRED = 276,
     LIMITED = 277,
     OUTOFBAND = 278,
     INSTREAM = 279,
     INOUT = 280,
     CONST = 281,
     THROW = 282,
     OBRACE = 283,
     EBRACE = 284,
     OBRACKET = 285,
     EBRACKET = 286,
     COMMA = 287,
     SEMICOLON = 288,
     COLON = 289,
     TWOCOLON = 290
   };
#endif
#define POINTER 258
#define REFERENCE 259
#define EQUALS 260
#define ENUM 261
#define UNSIGNED 262
#define SIGNED 263
#define COMMENT 264
#define INCLUDE 265
#define FLOATNUMBER 266
#define NUMBER 267
#define NUMBERWORD 268
#define WORD 269
#define STRING 270
#define OR 271
#define OTEMPLATE 272
#define CTEMPLATE 273
#define MODULE 274
#define INTERFACE 275
#define REQUIRED 276
#define LIMITED 277
#define OUTOFBAND 278
#define INSTREAM 279
#define INOUT 280
#define CONST 281
#define THROW 282
#define OBRACE 283
#define EBRACE 284
#define OBRACKET 285
#define EBRACKET 286
#define COMMA 287
#define SEMICOLON 288
#define COLON 289
#define TWOCOLON 290




/* Copy the first part of user declarations.  */
#line 12 "icppimpl.ypp"

#include "ycommon.hpp"

ostringstream interf_params;
ostringstream method_params;
ostringstream required_params;
ostringstream limited_params;
ostringstream mod_params;
unsigned ted_count = 0;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 168 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   144

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  44
/* YYNRULES -- Number of rules. */
#define YYNRULES  94
/* YYNRULES -- Number of states. */
#define YYNSTATES  140

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   290

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     7,     8,    10,    13,    15,    21,    23,
      24,    26,    29,    31,    33,    35,    37,    42,    50,    51,
      53,    57,    58,    62,    68,    78,    79,    82,    83,    85,
      89,    91,    94,    96,    99,   102,   104,   105,   107,   110,
     112,   121,   122,   124,   127,   129,   131,   133,   135,   137,
     139,   144,   145,   147,   151,   153,   158,   163,   164,   166,
     170,   172,   173,   175,   178,   180,   183,   186,   190,   192,
     193,   195,   199,   203,   209,   211,   213,   215,   217,   219,
     221,   223,   225,   228,   231,   234,   236,   240,   242,   245,
     248,   253,   254,   256,   260
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      37,     0,    -1,    66,    38,    42,    -1,    -1,    39,    -1,
      38,    39,    -1,    10,    -1,    19,    41,    28,    42,    29,
      -1,    14,    -1,    -1,    43,    -1,    42,    43,    -1,    48,
      -1,    40,    -1,    45,    -1,    44,    -1,    66,    20,    14,
      33,    -1,    66,     6,    14,    28,    46,    29,    33,    -1,
      -1,    47,    -1,    46,    32,    47,    -1,    -1,    66,    14,
      66,    -1,    66,    14,     5,    12,    66,    -1,    66,    20,
      54,    49,    28,    55,    66,    29,    33,    -1,    -1,    34,
      50,    -1,    -1,    51,    -1,    50,    32,    51,    -1,    14,
      -1,    52,    14,    -1,    53,    -1,    52,    53,    -1,    14,
      35,    -1,    14,    -1,    -1,    56,    -1,    55,    56,    -1,
      45,    -1,    66,    67,    68,    30,    69,    31,    57,    33,
      -1,    -1,    58,    -1,    57,    58,    -1,    26,    -1,    23,
      -1,    24,    -1,    62,    -1,    63,    -1,    59,    -1,    27,
      30,    60,    31,    -1,    -1,    61,    -1,    60,    32,    61,
      -1,    14,    -1,    21,    30,    64,    31,    -1,    22,    30,
      65,    31,    -1,    -1,    65,    -1,    64,    32,    65,    -1,
      75,    -1,    -1,     9,    -1,    66,     9,    -1,    72,    -1,
      26,    72,    -1,    72,    26,    -1,    26,    72,    26,    -1,
      14,    -1,    -1,    70,    -1,    70,    32,    69,    -1,    25,
      72,    79,    -1,    25,    72,    79,     5,    71,    -1,    12,
      -1,    11,    -1,    15,    -1,    51,    -1,    76,    -1,    77,
      -1,    73,    -1,    74,    -1,    72,     3,    -1,    76,     4,
      -1,    77,     4,    -1,    14,    -1,    75,    35,    14,    -1,
      75,    -1,     7,    14,    -1,     8,    14,    -1,    14,    17,
      78,    18,    -1,    -1,    72,    -1,    78,    32,    72,    -1,
      14,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    29,    29,    60,    64,    69,    76,    83,    93,    97,
     101,   106,   113,   118,   123,   128,   135,   142,   149,   153,
     158,   166,   170,   175,   182,   201,   204,   210,   213,   217,
     223,   227,   233,   237,   243,   249,   254,   258,   263,   270,
     275,   316,   320,   325,   332,   338,   343,   348,   353,   358,
     365,   372,   376,   381,   389,   393,   401,   409,   413,   418,
     426,   430,   434,   439,   446,   451,   456,   461,   468,   472,
     476,   481,   490,   516,   543,   548,   553,   558,   565,   570,
     575,   580,   587,   594,   599,   606,   611,   619,   624,   629,
     636,   643,   647,   652,   660
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "POINTER", "REFERENCE", "EQUALS", "ENUM", 
  "UNSIGNED", "SIGNED", "COMMENT", "INCLUDE", "FLOATNUMBER", "NUMBER", 
  "NUMBERWORD", "WORD", "STRING", "OR", "OTEMPLATE", "CTEMPLATE", 
  "MODULE", "INTERFACE", "REQUIRED", "LIMITED", "OUTOFBAND", "INSTREAM", 
  "INOUT", "CONST", "THROW", "OBRACE", "EBRACE", "OBRACKET", "EBRACKET", 
  "COMMA", "SEMICOLON", "COLON", "TWOCOLON", "$accept", "idl", "includes", 
  "include", "module", "module_name", "commands", "command", "forward", 
  "enum", "enum_entries", "enum_entry", "interface", "inheritance", 
  "superclasses", "superclass", "sclassnamespaces", "sclassnamespace", 
  "interface_name", "interface_methods", "interface_method", "modifiers", 
  "modifier", "throw_modifier", "exceptions", "exception", 
  "required_modifier", "limited_modifier", "comma_states", "state", 
  "comments", "return_value", "method_name", "parameters", "parameter", 
  "default_arg", "parameter_type", "pointer_type", "reference_type", 
  "twocolon_basic_type", "basic_type", "parameter_complex_type", 
  "parameter_type_list", "parameter_name", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    36,    37,    38,    38,    38,    39,    40,    41,    42,
      42,    42,    43,    43,    43,    43,    44,    45,    46,    46,
      46,    47,    47,    47,    48,    49,    49,    50,    50,    50,
      51,    51,    52,    52,    53,    54,    55,    55,    55,    56,
      56,    57,    57,    57,    58,    58,    58,    58,    58,    58,
      59,    60,    60,    60,    61,    62,    63,    64,    64,    64,
      65,    66,    66,    66,    67,    67,    67,    67,    68,    69,
      69,    69,    70,    70,    71,    71,    71,    71,    72,    72,
      72,    72,    73,    74,    74,    75,    75,    76,    76,    76,
      77,    78,    78,    78,    79
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     0,     1,     2,     1,     5,     1,     0,
       1,     2,     1,     1,     1,     1,     4,     7,     0,     1,
       3,     0,     3,     5,     9,     0,     2,     0,     1,     3,
       1,     2,     1,     2,     2,     1,     0,     1,     2,     1,
       8,     0,     1,     2,     1,     1,     1,     1,     1,     1,
       4,     0,     1,     3,     1,     4,     4,     0,     1,     3,
       1,     0,     1,     2,     1,     2,     2,     3,     1,     0,
       1,     3,     3,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     1,     3,     1,     2,     2,
       4,     0,     1,     3,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      61,    62,     0,     3,     1,    63,     6,     9,     4,     0,
       5,    13,    61,    10,    15,    14,    12,     0,     8,     0,
      11,     0,     0,     9,     0,    35,    25,    61,    18,    16,
      27,     0,     7,     0,    19,     0,    30,    26,    28,     0,
      32,    36,     0,    21,    61,    34,     0,    31,    33,    39,
      61,    37,     0,    17,    20,     0,    22,    29,    38,     0,
       0,     0,    85,     0,     0,    64,    80,    81,    87,    78,
      79,    61,     0,    88,    89,    91,    65,    68,     0,    82,
      66,     0,    83,    84,    23,    24,    92,     0,    67,    69,
      86,    90,     0,     0,     0,    70,    93,     0,    41,    69,
      94,    72,     0,     0,    45,    46,    44,     0,     0,    42,
      49,    47,    48,    71,     0,    57,     0,    51,    40,    43,
      75,    74,    76,    77,    73,    85,     0,    58,    60,     0,
      54,     0,    52,    55,     0,    56,    50,     0,    59,    53
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,     7,     8,    11,    19,    12,    13,    14,    15,
      33,    34,    16,    31,    37,    38,    39,    40,    26,    50,
      51,   108,   109,   110,   131,   132,   111,   112,   126,   127,
      17,    64,    78,    94,    95,   124,    65,    66,    67,    68,
      69,    70,    87,   101
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -108
static const yysigned_char yypact[] =
{
      29,  -108,    13,    37,  -108,  -108,  -108,    51,  -108,    49,
    -108,  -108,    20,  -108,  -108,  -108,  -108,    36,  -108,    40,
    -108,    77,    79,    53,    68,    32,    67,     6,    65,  -108,
      86,    71,  -108,    63,  -108,    73,    69,    70,  -108,    89,
    -108,    29,    72,    65,    85,  -108,    86,    69,  -108,  -108,
      29,  -108,    10,  -108,  -108,    94,    98,  -108,  -108,    -3,
      95,    96,    91,    59,    97,     4,  -108,  -108,    78,   108,
     110,    29,    82,  -108,  -108,    59,     7,  -108,    87,  -108,
    -108,   102,  -108,  -108,    98,  -108,   115,    19,  -108,    99,
    -108,  -108,    59,    59,    88,    90,   115,    45,    54,    99,
    -108,   116,    93,   100,  -108,  -108,  -108,   101,    31,  -108,
    -108,  -108,  -108,  -108,    74,   106,   106,   111,  -108,  -108,
    -108,  -108,  -108,  -108,  -108,  -108,    52,  -108,    78,   103,
    -108,    66,  -108,  -108,   106,  -108,  -108,   111,  -108,  -108
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
    -108,  -108,  -108,   119,  -108,  -108,   104,    22,  -108,   -29,
    -108,    92,  -108,  -108,  -108,   -45,  -108,   105,  -108,  -108,
      83,  -108,    21,  -108,  -108,    -9,  -108,  -108,  -108,   -94,
       0,  -108,  -108,    33,  -108,  -108,   -61,  -108,  -108,  -107,
    -108,  -108,  -108,  -108
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -62
static const short yytable[] =
{
       3,    57,    76,    21,    60,    61,     5,    79,   128,   128,
      79,    62,    49,     4,    86,     1,    21,    60,    61,     5,
      -2,    49,   129,    63,    62,     9,    72,   128,    35,     1,
      80,    96,    97,    88,    20,    32,    63,    91,     1,     9,
     138,    52,    21,    35,    56,     5,     5,     6,    79,    20,
      59,    92,   102,   103,   104,   105,    22,   106,   107,   100,
       1,     6,     1,    18,   118,    29,    60,    61,    23,   123,
       9,    84,     9,    62,     1,   102,   103,   104,   105,   -61,
     106,   107,     5,   133,   134,   120,   121,    44,    36,   122,
      55,    24,    42,    25,     1,    43,    28,   136,   137,    41,
      36,    30,    46,    47,    45,    53,    71,     5,    75,    73,
      74,    77,    82,    81,    83,    85,    90,    89,    79,    98,
     125,   114,    99,   115,    93,   130,    10,    27,   139,   119,
     116,   117,   113,    58,   135,    54,     0,     0,     0,     0,
       0,     0,     0,     0,    48
};

static const short yycheck[] =
{
       0,    46,    63,     6,     7,     8,     9,     3,   115,   116,
       3,    14,    41,     0,    75,     9,     6,     7,     8,     9,
       0,    50,   116,    26,    14,    19,    29,   134,    28,     9,
      26,    92,    93,    26,    12,    29,    26,    18,     9,    19,
     134,    41,     6,    43,    44,     9,     9,    10,     3,    27,
      50,    32,    21,    22,    23,    24,    20,    26,    27,    14,
       9,    10,     9,    14,    33,    33,     7,     8,    28,   114,
      19,    71,    19,    14,     9,    21,    22,    23,    24,    14,
      26,    27,     9,    31,    32,    11,    12,    14,    14,    15,
       5,    14,    29,    14,     9,    32,    28,    31,    32,    28,
      14,    34,    32,    14,    35,    33,    12,     9,    17,    14,
      14,    14,     4,    35,     4,    33,    14,    30,     3,    31,
      14,     5,    32,    30,    25,    14,     7,    23,   137,   108,
      30,    30,    99,    50,    31,    43,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     9,    37,    66,     0,     9,    10,    38,    39,    19,
      39,    40,    42,    43,    44,    45,    48,    66,    14,    41,
      43,     6,    20,    28,    14,    14,    54,    42,    28,    33,
      34,    49,    29,    46,    47,    66,    14,    50,    51,    52,
      53,    28,    29,    32,    14,    35,    32,    14,    53,    45,
      55,    56,    66,    33,    47,     5,    66,    51,    56,    66,
       7,     8,    14,    26,    67,    72,    73,    74,    75,    76,
      77,    12,    29,    14,    14,    17,    72,    14,    68,     3,
      26,    35,     4,     4,    66,    33,    72,    78,    26,    30,
      14,    18,    32,    25,    69,    70,    72,    72,    31,    32,
      14,    79,    21,    22,    23,    24,    26,    27,    57,    58,
      59,    62,    63,    69,     5,    30,    30,    30,    33,    58,
      11,    12,    15,    51,    71,    14,    64,    65,    75,    65,
      14,    60,    61,    31,    32,    31,    31,    32,    65,    61
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 30 "icppimpl.ypp"
    {
	 size_t start = filename.find_last_of("/");
	 size_t end   = filename.find_last_of(".");
	 if(end < start+1) {
	   cerr << "Ups, strange filename, please check!" << endl;
	   exit(1);
	 }
	 string s = filename.substr(start+1, end - start - 1);
	 s+="Impl";

         cout << yyvsp[-2] << endl;

	 cout << "#include \""<< s << ".hpp\"" << endl
	      << "#include \"nmm/comm/serialize/SerializeResult.hpp\"" << endl 
	      << "#include \"nmm/comm/messaging/TEDObject.hpp\"" << endl << endl;

   cout << "#include \"nmm/nmm_prefix.hpp\"" << endl
        << endl;

         cout << __get_extra_in_file(filename, "Impl.cpp.in");

	 cout << endl
	      << yyvsp[0] << endl;

   cout << "#include \"nmm/nmm_suffix.hpp\"" << endl
        << endl;
       }
    break;

  case 3:
#line 60 "icppimpl.ypp"
    {
	  __set(yyval, "");
        }
    break;

  case 4:
#line 65 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 5:
#line 70 "icppimpl.ypp"
    {
	  __append(yyval, yyvsp[0]);
	}
    break;

  case 6:
#line 77 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0] << endl);
	}
    break;

  case 7:
#line 84 "icppimpl.ypp"
    {
	  __set(yyval, "namespace " << yyvsp[-3] << endl
		<< "{" << endl
		<< yyvsp[-1] << endl
		<< "}" << endl << endl);
	}
    break;

  case 9:
#line 97 "icppimpl.ypp"
    {
	  __set(yyval, "");
	}
    break;

  case 10:
#line 102 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 11:
#line 107 "icppimpl.ypp"
    {
	  __append(yyval, yyvsp[0]);
	}
    break;

  case 12:
#line 114 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 13:
#line 119 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 14:
#line 124 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 15:
#line 129 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 16:
#line 136 "icppimpl.ypp"
    {
          __set(yyval, "");
        }
    break;

  case 17:
#line 143 "icppimpl.ypp"
    {
	  __set(yyval, "");
        }
    break;

  case 18:
#line 149 "icppimpl.ypp"
    {
	  __set(yyval, "");
	}
    break;

  case 19:
#line 154 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 20:
#line 159 "icppimpl.ypp"
    {
	  __append(yyval, ", ");
	  __append(yyval, yyvsp[0]);
        }
    break;

  case 21:
#line 166 "icppimpl.ypp"
    {
	  __set(yyval, "");
        }
    break;

  case 22:
#line 171 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[-2] << "\n    " << yyvsp[-1] << " " << yyvsp[0]);
        }
    break;

  case 23:
#line 176 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[-4] << "\n    " << yyvsp[-3] << " = " << yyvsp[-1] << " " << yyvsp[0]);
        }
    break;

  case 24:
#line 183 "icppimpl.ypp"
    {
	  /* replace all $$CLASS$$ set in interface_method with the interface name */
	  string s = yyvsp[-3];
	  string i = yyvsp[-6];
	  __replace(s, "$$INTERFACE$$", i);

	  string s2 = i + "Impl";
	  __replace(s, "$$CLASS$$", s2);

	  __set(yyval, "  " << endl
		<< "  void " << s2 << "::registerEvents()" << endl
		<< "  {" << endl
		<< s << endl
		<< "  }" << endl);
	}
    break;

  case 25:
#line 201 "icppimpl.ypp"
    {
	}
    break;

  case 26:
#line 205 "icppimpl.ypp"
    {
	}
    break;

  case 27:
#line 210 "icppimpl.ypp"
    {
	}
    break;

  case 28:
#line 214 "icppimpl.ypp"
    {
        }
    break;

  case 29:
#line 218 "icppimpl.ypp"
    {
        }
    break;

  case 30:
#line 224 "icppimpl.ypp"
    {
	}
    break;

  case 31:
#line 228 "icppimpl.ypp"
    {
	}
    break;

  case 32:
#line 234 "icppimpl.ypp"
    {
        }
    break;

  case 33:
#line 238 "icppimpl.ypp"
    {
        }
    break;

  case 34:
#line 244 "icppimpl.ypp"
    {
	}
    break;

  case 36:
#line 254 "icppimpl.ypp"
    {
	  __set(yyval, "");
	}
    break;

  case 37:
#line 259 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 38:
#line 264 "icppimpl.ypp"
    {
	  __append(yyval, yyvsp[0]);
	}
    break;

  case 39:
#line 271 "icppimpl.ypp"
    {
	  __set(yyval, "");
        }
    break;

  case 40:
#line 276 "icppimpl.ypp"
    {
	  string lp = limited_params.str();
	  string rp = required_params.str();
	  string m_name = yyvsp[-5];
	  __replace(lp, "$$METHOD$$", m_name);
	  __replace(rp, "$$METHOD$$", m_name);

	  ostringstream s;
	  s << "  " << endl;
	  
	  s << "    getEventDispatcher().registerEvent($$INTERFACE$$::" << yyvsp[-5] << "_event, "
	    << "new NMM::TEDObject" << ted_count 
	    << "<$$CLASS$$, " 
	    << interf_params.str()  
	    << yyvsp[-6] << "($$CLASS$$:: * )(" << method_params.str() << ")" 
	    << mod_params.str() << ", "
	    << yyvsp[-6] << " >"
	    << "(this, &$$CLASS$$::" << yyvsp[-5] << suffix;

	  s << "));" << endl;

	  if(lp.size() > 0) {
	    s << lp;	
          }
	  if(rp.size() > 0) {
	    s << rp;
          }

	  __set(yyval, s.str());

	  ted_count = 0;
	  interf_params.str("");
	  method_params.str("");
	  required_params.str("");
	  limited_params.str("");
	  mod_params.str("");
	}
    break;

  case 41:
#line 316 "icppimpl.ypp"
    {
	  __set(yyval, "");
        }
    break;

  case 42:
#line 321 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 43:
#line 326 "icppimpl.ypp"
    {
	  __append(yyval, yyvsp[0]);
	}
    break;

  case 44:
#line 333 "icppimpl.ypp"
    {
	  __set(yyval, " " << yyvsp[0]);
	  mod_params << " " << yyvsp[0];
	}
    break;

  case 45:
#line 339 "icppimpl.ypp"
    {
	  __set(yyval, " /* out of band */ ");
	}
    break;

  case 46:
#line 344 "icppimpl.ypp"
    {
	  __set(yyval, " /* in-stream */ ");
	}
    break;

  case 47:
#line 349 "icppimpl.ypp"
    {
	  __set(yyval, " " << yyvsp[0]);
	}
    break;

  case 48:
#line 354 "icppimpl.ypp"
    {
	  __set(yyval, " " << yyvsp[0]);
	}
    break;

  case 49:
#line 359 "icppimpl.ypp"
    {
	  __set(yyval, " " << yyvsp[0]);
	}
    break;

  case 50:
#line 366 "icppimpl.ypp"
    {
	  __set(yyval, "\n      throw(" << yyvsp[-1] << ")");
	}
    break;

  case 51:
#line 372 "icppimpl.ypp"
    {
	  __set(yyval, "");
        }
    break;

  case 52:
#line 377 "icppimpl.ypp"
    {
	  __set(yyval, "const " << yyvsp[0] <<"&");
	}
    break;

  case 53:
#line 382 "icppimpl.ypp"
    {
	  __append(yyval, ", ");
	  __append(yyval, yyvsp[0]);
	}
    break;

  case 55:
#line 394 "icppimpl.ypp"
    {
	  __set(yyval, "/* required(" << yyvsp[-1] << ") */"); /* no not set anything */
	  required_params << "    getEventDispatcher().addRequired($$INTERFACE$$::$$METHOD$$_event, " << yyvsp[-1] << ");" << endl;	
	}
    break;

  case 56:
#line 402 "icppimpl.ypp"
    {
	  __set(yyval, "/* limited(" << yyvsp[-1] << ") */"); /* no not set anything */
	  limited_params << "    getEventDispatcher().addLimited($$INTERFACE$$::$$METHOD$$_event, " << yyvsp[-1] << ");" << endl;
	}
    break;

  case 57:
#line 409 "icppimpl.ypp"
    {
	  __set(yyval, "");
        }
    break;

  case 58:
#line 414 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 59:
#line 419 "icppimpl.ypp"
    {
	  __append(yyval, ", ");
	  __append(yyval, yyvsp[0]);
	}
    break;

  case 61:
#line 430 "icppimpl.ypp"
    {
	  __set(yyval, "");
        }
    break;

  case 62:
#line 435 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 63:
#line 440 "icppimpl.ypp"
    {
	  __append(yyval, yyvsp[0]);
	}
    break;

  case 64:
#line 447 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 65:
#line 452 "icppimpl.ypp"
    {
	  __set(yyval, "const " << yyvsp[0]);
        }
    break;

  case 66:
#line 457 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[-1] << " const");
        }
    break;

  case 67:
#line 462 "icppimpl.ypp"
    {
	  __set(yyval, "const " << yyvsp[-1] << " const");
        }
    break;

  case 69:
#line 472 "icppimpl.ypp"
    {
	  __set(yyval, "");
	}
    break;

  case 70:
#line 477 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 71:
#line 482 "icppimpl.ypp"
    {
	  __append(yyval, ", ");
	  __append(yyval, yyvsp[0]);

	}
    break;

  case 72:
#line 491 "icppimpl.ypp"
    {
	  if(ted_count > 0) {
	    method_params << ", ";
	  }

	  ted_count++;

	  if(!strcmp(yyvsp[-2],"in")) {
            // in pointers do not get & added
	    string s = yyvsp[-1];
            string ref = "&";
	    if(s.substr(s.size() - 1, 1) == "*") { 
              ref = "";
 	    }
	    __set(yyval, "const " << yyvsp[-1] << ref << " " << yyvsp[0]);
	    method_params << "const " << yyvsp[-1] << ref;
	  }
	  else {
	    __set(yyval, yyvsp[-1] << "& " << yyvsp[0]);
	    method_params << yyvsp[-1] << "&";
	  }

	  interf_params << yyvsp[-1] << ", ";
	}
    break;

  case 73:
#line 517 "icppimpl.ypp"
    {
	  if(ted_count > 0) {
	    method_params << ", ";
	  }

	  ted_count++;
	  if(!strcmp(yyvsp[-4],"in")) {
            // in pointers do not get & added
	    string s = yyvsp[-3];
            string ref = "&";
	    if(s.substr(s.size() - 1, 1) == "*") { 
              ref = "";
 	    }
	    __set(yyval, "const " << yyvsp[-3] << ref << " " << yyvsp[-2] << " = " << yyvsp[0]);
	    method_params << "const " << yyvsp[-3] << ref;
	  }
	  else {
	    yyerror("only parameters declared as 'in' can have default arguments");
            YYERROR;
	  }

	  interf_params << yyvsp[-3] << ", ";
	}
    break;

  case 74:
#line 544 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 75:
#line 549 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 76:
#line 554 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 77:
#line 559 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
        }
    break;

  case 78:
#line 566 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 79:
#line 571 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 80:
#line 576 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 81:
#line 581 "icppimpl.ypp"
    {
	  __set(yyval, "/* WARNING: reference return types are currently not supported, references as parameters should be specifies by using in our inout */ " << yyvsp[0]);
	}
    break;

  case 82:
#line 588 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[-1] << "*");
        }
    break;

  case 83:
#line 595 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[-1] << "&");
        }
    break;

  case 84:
#line 600 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[-1] << "&");
        }
    break;

  case 85:
#line 607 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 86:
#line 612 "icppimpl.ypp"
    {
	  __append(yyval, "::");
	  __append(yyval, yyvsp[0]);
	}
    break;

  case 87:
#line 620 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 88:
#line 625 "icppimpl.ypp"
    {
	  __set(yyval, "unsigned " << yyvsp[0]);
	}
    break;

  case 89:
#line 630 "icppimpl.ypp"
    {
	  __set(yyval, "signed " << yyvsp[0]);
	}
    break;

  case 90:
#line 637 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[-3] << "<" << yyvsp[-1] << " > ");
        }
    break;

  case 91:
#line 643 "icppimpl.ypp"
    {
	  __set(yyval, "");
	}
    break;

  case 92:
#line 648 "icppimpl.ypp"
    {
	  __set(yyval, yyvsp[0]);
	}
    break;

  case 93:
#line 653 "icppimpl.ypp"
    {
	  __append(yyval, ", ");
	  __append(yyval, yyvsp[0]);
	}
    break;


    }

/* Line 991 of yacc.c.  */
#line 1909 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



