/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version. 
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


#ifndef NMM_DEFAULT_SINKS_LINUX_HPP
#define NMM_DEFAULT_SINKS_LINUX_HPP NMM_DEFAULT_SINKS_LINUX_HPP

#include "nmm/nmm_prefix.hpp"

namespace NMM {
  
  /** Name of default audio sink node.
   */
  static const char DEFAULT_AUDIO_SINK[] = "MacOSXPlaybackNode";
  
  /** Name of default video sink node.
   */
  static const char DEFAULT_VIDEO_SINK[] = "XDisplayNode";
  
}

#include "nmm/nmm_suffix.hpp"

#endif
