/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     CONNECTION_PARAMETER = 258,
     CONFIG_PARAMETER = 259,
     GD_SET_EVENT_TRANSPORT_STRATEGY = 260,
     GD_INSTREAM_BUFFER_TRANSPORT_STRATEGY = 261,
     GD_SHARING = 262,
     GD_FORMAT = 263,
     GD_HOST = 264,
     GD_PORT = 265,
     GD_AUDIO_CODEC = 266,
     GD_AUDIO_FORMAT = 267,
     GD_AUDIO_FORMAT_STRING = 268,
     GD_BITPERPIXEL = 269,
     GD_BITPERSAMPLE = 270,
     GD_BITRATE = 271,
     GD_CHANNELORDER = 272,
     GD_CHANNELS = 273,
     GD_COLORSPACE = 274,
     GD_COMPRESSOR = 275,
     GD_ENCODEING = 276,
     GD_ENDIAN = 277,
     GD_FRAMERATE = 278,
     GD_LAYER = 279,
     GD_NUM_AUDIO_STREAMS = 280,
     GD_NUM_VIDEO_STREAMS = 281,
     GD_QUALITY = 282,
     GD_RATIO_X = 283,
     GD_RATIO_Y = 284,
     GD_SAMPLE_RATE = 285,
     GD_SIGN = 286,
     GD_VERSION = 287,
     GD_VIDEO_FORMAT = 288,
     GD_X_RESOLUTION = 289,
     GD_Y_RESOLUTION = 290,
     GD_FORMAT_TYPE = 291,
     FLOATNUMBER = 292,
     NUMBER = 293,
     NUMBERIDENTIFIER = 294,
     STRINGIDENTIFIER = 295,
     CONNECT = 296,
     OBRACE = 297,
     EBRACE = 298,
     OBRACKET = 299,
     EBRACKET = 300,
     OSQUARE_BRACKET = 301,
     ESQUARE_BRACKET = 302,
     EQUAL = 303,
     COMMA = 304,
     NODE_PARAMETER = 305,
     IDENTIFIER = 306,
     GD_FORMAT_PARAM = 307,
     GD_FORMAT_AC3_AUDIO_STREAMS_PARAM = 308,
     GD_FORMAT_MPEG_AUDIO_STEAMS = 309,
     GD_FORMAT_DTS_AUDIO_STREAMS = 310,
     GD_FORMAT_LPCM_AUDIO_STREAMS = 311,
     GD_FORMAT_MPEG_VIDEO_STERAMS = 312,
     GD_FORMAT_SPU_STERAMS = 313,
     GD_MAP_AC3_AUDIO_STREAMS = 314,
     GD_MAP_MPEG_AUDIO_STREAMS = 315,
     GD_MAP_DTS_AUDIO_STREAMS = 316,
     GD_MAP_LPCM_AUDIO_STREAMS = 317,
     GD_MAP_MPEG_VIDEO_STREAMS = 318,
     GD_MAP_SPU_STREAMS = 319,
     STATE_CONSTRUCTED = 320,
     STATE_INITIALIZED = 321,
     STATE_OUTPUT_INITIALIZED = 322,
     STATE_ACTIVATED = 323,
     STATE_STARTED = 324,
     COMMENT = 325,
     TYPE_SHARED = 326,
     TYPE_EXCLUSIVE = 327,
     TYPE_SHARED_OR_EXCLUSIVE = 328,
     TYPE_EXCLUSIVE_OR_SHARED = 329,
     TYPE_EXCLUSIVE_THEN_SHARED = 330,
     TYPE_SHARED_OR_EXCLUSIVE_THEN_SHARED = 331,
     TYPE_EXCLUSIVE_THEN_SHARED_OR_SHARED = 332
   };
#endif
#define CONNECTION_PARAMETER 258
#define CONFIG_PARAMETER 259
#define GD_SET_EVENT_TRANSPORT_STRATEGY 260
#define GD_INSTREAM_BUFFER_TRANSPORT_STRATEGY 261
#define GD_SHARING 262
#define GD_FORMAT 263
#define GD_HOST 264
#define GD_PORT 265
#define GD_AUDIO_CODEC 266
#define GD_AUDIO_FORMAT 267
#define GD_AUDIO_FORMAT_STRING 268
#define GD_BITPERPIXEL 269
#define GD_BITPERSAMPLE 270
#define GD_BITRATE 271
#define GD_CHANNELORDER 272
#define GD_CHANNELS 273
#define GD_COLORSPACE 274
#define GD_COMPRESSOR 275
#define GD_ENCODEING 276
#define GD_ENDIAN 277
#define GD_FRAMERATE 278
#define GD_LAYER 279
#define GD_NUM_AUDIO_STREAMS 280
#define GD_NUM_VIDEO_STREAMS 281
#define GD_QUALITY 282
#define GD_RATIO_X 283
#define GD_RATIO_Y 284
#define GD_SAMPLE_RATE 285
#define GD_SIGN 286
#define GD_VERSION 287
#define GD_VIDEO_FORMAT 288
#define GD_X_RESOLUTION 289
#define GD_Y_RESOLUTION 290
#define GD_FORMAT_TYPE 291
#define FLOATNUMBER 292
#define NUMBER 293
#define NUMBERIDENTIFIER 294
#define STRINGIDENTIFIER 295
#define CONNECT 296
#define OBRACE 297
#define EBRACE 298
#define OBRACKET 299
#define EBRACKET 300
#define OSQUARE_BRACKET 301
#define ESQUARE_BRACKET 302
#define EQUAL 303
#define COMMA 304
#define NODE_PARAMETER 305
#define IDENTIFIER 306
#define GD_FORMAT_PARAM 307
#define GD_FORMAT_AC3_AUDIO_STREAMS_PARAM 308
#define GD_FORMAT_MPEG_AUDIO_STEAMS 309
#define GD_FORMAT_DTS_AUDIO_STREAMS 310
#define GD_FORMAT_LPCM_AUDIO_STREAMS 311
#define GD_FORMAT_MPEG_VIDEO_STERAMS 312
#define GD_FORMAT_SPU_STERAMS 313
#define GD_MAP_AC3_AUDIO_STREAMS 314
#define GD_MAP_MPEG_AUDIO_STREAMS 315
#define GD_MAP_DTS_AUDIO_STREAMS 316
#define GD_MAP_LPCM_AUDIO_STREAMS 317
#define GD_MAP_MPEG_VIDEO_STREAMS 318
#define GD_MAP_SPU_STREAMS 319
#define STATE_CONSTRUCTED 320
#define STATE_INITIALIZED 321
#define STATE_OUTPUT_INITIALIZED 322
#define STATE_ACTIVATED 323
#define STATE_STARTED 324
#define COMMENT 325
#define TYPE_SHARED 326
#define TYPE_EXCLUSIVE 327
#define TYPE_SHARED_OR_EXCLUSIVE 328
#define TYPE_EXCLUSIVE_OR_SHARED 329
#define TYPE_EXCLUSIVE_THEN_SHARED 330
#define TYPE_SHARED_OR_EXCLUSIVE_THEN_SHARED 331
#define TYPE_EXCLUSIVE_THEN_SHARED_OR_SHARED 332




/* Copy the first part of user declarations.  */
#line 12 "GraphDescriptionParser.ypp"

#include "ycommon.hpp"

#include <queue>
#include "nmm/comm/format/Format.hpp"
#include "nmm/services/registry/GraphDescription.hpp"
#include "nmm/services/registry/ClientRegistry.hpp"
#include "GDParse.hpp"
#include "visibility.hpp"

#define YYDEBUG 1
using namespace NMM;

struct MuxConnection {
  MuxConnection(NodeDescription* _nd, const string& _out_tag, const string& _mux_in_tag, Format* _format = 0, const string& _c_strategy_buffer = "", const string& _c_strategy_event = "")
    : nd(_nd), out_tag(_out_tag), mux_in_tag(_mux_in_tag), format(_format), c_strategy_buffer(_c_strategy_buffer), c_strategy_event(_c_strategy_event)
  {}

  NodeDescription* nd;
  string out_tag;
  string mux_in_tag;
  Format* format;
  string  c_strategy_buffer;     //TransportStrategy that should be used for instream buffer
  string  c_strategy_event;      //TransportStrategy that should be used for instream events
};

struct DemuxConnection {
  DemuxConnection() :  nd(0), format(0) {}
  DemuxConnection(NodeDescription* _nd, Format* _format, const string& _c_strategy_buffer = "", const string& _c_strategy_event="")
    : nd(_nd), format(_format), c_strategy_buffer(_c_strategy_buffer), c_strategy_event(_c_strategy_event)
  { }

  NodeDescription*  nd;
  Format*           format;
  string  c_strategy_buffer;     //TransportStrategy that should be used for instream buffer
  string  c_strategy_event;      //TransportStrategy that should be used for instream events
};


queue<NodeDescription*> nd_queue;                         ///< stores all NodeDescription in the order they were allocated

list<NodeDescription*> nd_list;                         ///< stores all NodeDescription in the order they were allocated

queue<NodeDescription*> start_branch_queue;               ///< stores the end of branches that must be connected with a Muxer
list< MuxConnection > end_branch_list;                  ///< stores the NodeDescription and jack_tag of an ending branch that must be connected with a Muxer

GraphDescription* g=NULL;                                 ///< The GraphDescription used dureing graph parsing.

NodeDescription* left_nd = 0;
string left_intag = "";
string left_outtag = "";

NodeDescription* right_nd = 0;
string right_intag = "";
string right_outtag = "";

Format* format = 0;                                        ///< stores the current connection format
list<int> i_list;                                          ///< stores temporary int-values for Format-Ranges
list<float> f_list;                                          ///< stores temporary float-values for Format-Ranges
string  c_strategy_buffer;                                 ///< stores the current transport strategy used to connect nodes and transport instream buffer
string  c_strategy_event;                                  ///< stores the current transport strategy used to connect nodes and transport instream events
string  n_strategy;                                        ///< stores the current transport strategy used to connect a ProxyObject with its NMMObject

string __current_host ;                                    ///< stores the current location
int __current_port = ClientRegistry::default_port;         ///< stores the current port 

NodeDescription::SharingType sharing_type = NodeDescription::EXCLUSIVE_OR_SHARED;  ///< Sharing type for a node

NodeConfiguration       __current_node_configuration;      ///< stores the node configuration of the current node
NCElement*              __current_nc_element = 0;          ///< store the elements of the current configuration

queue< DemuxConnection > __demuxer_format_stack;   ///< stores the format for open demuxer connections.
list<NodeDescription*>   __demuxer_list;           //stores all demuxer nodes
list< DemuxConnection >  __demux_connection;       //stores all information about a demux connection

typedef pair<string, NodeDescription*> RootNode; 
list<RootNode>   __starting_subgraph_list; //stores the NodeDescriptions that starts a subgraph

bool starting_subgraph = true;
bool store_first_leftnode = true;
bool connect_muxer_nodes = false;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 323 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   286

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  78
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  31
/* YYNRULES -- Number of rules. */
#define YYNRULES  157
/* YYNRULES -- Number of states. */
#define YYNSTATES  274

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   332

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     7,     8,    10,    13,    15,    17,    19,
      23,    27,    31,    35,    37,    40,    42,    44,    48,    50,
      54,    56,    63,    70,    77,    80,    82,    85,    87,    93,
      99,   105,   109,   113,   119,   124,   128,   132,   137,   142,
     144,   146,   148,   150,   152,   154,   156,   158,   161,   163,
     170,   177,   184,   186,   194,   201,   203,   207,   209,   211,
     213,   215,   217,   219,   221,   223,   224,   226,   227,   229,
     231,   233,   237,   239,   243,   247,   251,   255,   259,   263,
     267,   273,   277,   281,   285,   289,   293,   297,   301,   305,
     309,   313,   317,   323,   327,   331,   337,   341,   347,   351,
     355,   359,   363,   367,   373,   377,   383,   387,   391,   395,
     399,   403,   407,   411,   415,   419,   423,   427,   431,   435,
     437,   439,   441,   443,   445,   447,   449,   451,   453,   455,
     457,   459,   461,   463,   465,   467,   469,   471,   473,   475,
     477,   479,   481,   483,   485,   487,   489,   491,   493,   495,
     497,   499,   501,   503,   505,   507,   509,   511
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      79,     0,    -1,    82,    83,    86,    -1,    -1,    80,    -1,
      70,    82,    -1,    80,    -1,    40,    -1,    80,    -1,    46,
      40,    47,    -1,    46,    51,    47,    -1,    46,    40,    47,
      -1,    46,    51,    47,    -1,    40,    -1,    94,    86,    -1,
      80,    -1,    38,    -1,    87,    49,    87,    -1,    37,    -1,
      88,    49,    88,    -1,    80,    -1,    89,     3,     8,    44,
     106,    45,    -1,    89,     3,     5,    44,    40,    45,    -1,
      89,     3,     6,    44,    40,    45,    -1,    89,    41,    -1,
      90,    -1,    93,    92,    -1,    80,    -1,    42,    85,    91,
      95,    43,    -1,    42,    85,    91,    86,    43,    -1,    42,
      85,    91,    84,    43,    -1,    95,    90,    96,    -1,    94,
      90,    96,    -1,    95,    42,    81,    92,    43,    -1,    42,
      81,    92,    43,    -1,    94,    90,    84,    -1,    95,    90,
      84,    -1,   103,   105,   104,    98,    -1,   103,   105,   104,
      98,    -1,    71,    -1,    72,    -1,    73,    -1,    74,    -1,
      75,    -1,    77,    -1,    76,    -1,    80,    -1,    99,   100,
      -1,    80,    -1,    99,    50,    10,    44,    38,    45,    -1,
      99,    50,     9,    44,    40,    45,    -1,    99,    50,     7,
      44,    97,    45,    -1,    80,    -1,   100,     4,    51,    44,
     101,    45,   102,    -1,   100,     4,     5,    44,    40,    45,
      -1,    80,    -1,   101,    49,   101,    -1,    40,    -1,    38,
      -1,    37,    -1,    65,    -1,    66,    -1,    67,    -1,    68,
      -1,    69,    -1,    -1,    40,    -1,    -1,    40,    -1,    51,
      -1,   107,    -1,   106,    49,   107,    -1,    40,    -1,    36,
      48,   108,    -1,    11,    48,    38,    -1,    12,    48,   108,
      -1,    13,    48,   108,    -1,    14,    48,    38,    -1,    15,
      48,    38,    -1,    16,    48,    38,    -1,    16,    48,    46,
      87,    47,    -1,    17,    48,   108,    -1,    18,    48,    38,
      -1,    19,    48,   108,    -1,    20,    48,   108,    -1,    21,
      48,   108,    -1,    22,    48,   108,    -1,    23,    48,    37,
      -1,    24,    48,    38,    -1,    25,    48,    38,    -1,    26,
      48,    38,    -1,    27,    48,    37,    -1,    27,    48,    46,
      88,    47,    -1,    27,    48,    38,    -1,    28,    48,    38,
      -1,    28,    48,    46,    87,    47,    -1,    29,    48,    38,
      -1,    29,    48,    46,    87,    47,    -1,    30,    48,    38,
      -1,    31,    48,   108,    -1,    32,    48,    38,    -1,    33,
      48,   108,    -1,    34,    48,    38,    -1,    34,    48,    46,
      87,    47,    -1,    35,    48,    38,    -1,    35,    48,    46,
      87,    47,    -1,    52,    48,   108,    -1,    53,    48,    38,
      -1,    54,    48,    38,    -1,    55,    48,   108,    -1,    56,
      48,    38,    -1,    57,    48,    38,    -1,    58,    48,    38,
      -1,    59,    48,    38,    -1,    60,    48,    38,    -1,    61,
      48,    38,    -1,    62,    48,    38,    -1,    63,    48,    38,
      -1,    64,    48,    38,    -1,    11,    -1,    12,    -1,    13,
      -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,    18,
      -1,    19,    -1,    20,    -1,    21,    -1,    22,    -1,    23,
      -1,    24,    -1,    25,    -1,    26,    -1,    27,    -1,    28,
      -1,    29,    -1,    30,    -1,    31,    -1,    32,    -1,    33,
      -1,    34,    -1,    35,    -1,    52,    -1,    53,    -1,    54,
      -1,    55,    -1,    56,    -1,    57,    -1,    58,    -1,    59,
      -1,    60,    -1,    61,    -1,    62,    -1,    63,    -1,    64,
      -1,    40,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   100,   100,   130,   134,   146,   150,   153,   158,   163,
     170,   177,   184,   189,   198,   203,   207,   211,   216,   220,
     225,   227,   232,   238,   247,   252,   287,   291,   295,   330,
     376,   400,   423,   446,   461,   476,   489,   502,   584,   619,
     623,   627,   631,   635,   639,   643,   649,   651,   657,   659,
     664,   671,   677,   679,   692,   699,   701,   706,   716,   724,
     736,   744,   751,   758,   765,   774,   778,   787,   791,   800,
     806,   809,   813,   823,   830,   836,   842,   848,   854,   860,
     866,   875,   881,   887,   893,   899,   905,   911,   917,   923,
     929,   935,   941,   950,   956,   962,   971,   977,   986,   992,
     998,  1004,  1010,  1016,  1025,  1031,  1040,  1046,  1052,  1058,
    1064,  1070,  1076,  1082,  1088,  1094,  1100,  1106,  1112,  1118,
    1124,  1130,  1136,  1142,  1148,  1154,  1160,  1166,  1172,  1178,
    1184,  1190,  1196,  1202,  1208,  1214,  1220,  1226,  1232,  1238,
    1244,  1250,  1256,  1262,  1268,  1274,  1280,  1286,  1292,  1298,
    1304,  1310,  1316,  1322,  1328,  1334,  1340,  1348
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "CONNECTION_PARAMETER", "CONFIG_PARAMETER", 
  "GD_SET_EVENT_TRANSPORT_STRATEGY", 
  "GD_INSTREAM_BUFFER_TRANSPORT_STRATEGY", "GD_SHARING", "GD_FORMAT", 
  "GD_HOST", "GD_PORT", "GD_AUDIO_CODEC", "GD_AUDIO_FORMAT", 
  "GD_AUDIO_FORMAT_STRING", "GD_BITPERPIXEL", "GD_BITPERSAMPLE", 
  "GD_BITRATE", "GD_CHANNELORDER", "GD_CHANNELS", "GD_COLORSPACE", 
  "GD_COMPRESSOR", "GD_ENCODEING", "GD_ENDIAN", "GD_FRAMERATE", 
  "GD_LAYER", "GD_NUM_AUDIO_STREAMS", "GD_NUM_VIDEO_STREAMS", 
  "GD_QUALITY", "GD_RATIO_X", "GD_RATIO_Y", "GD_SAMPLE_RATE", "GD_SIGN", 
  "GD_VERSION", "GD_VIDEO_FORMAT", "GD_X_RESOLUTION", "GD_Y_RESOLUTION", 
  "GD_FORMAT_TYPE", "FLOATNUMBER", "NUMBER", "NUMBERIDENTIFIER", 
  "STRINGIDENTIFIER", "CONNECT", "OBRACE", "EBRACE", "OBRACKET", 
  "EBRACKET", "OSQUARE_BRACKET", "ESQUARE_BRACKET", "EQUAL", "COMMA", 
  "NODE_PARAMETER", "IDENTIFIER", "GD_FORMAT_PARAM", 
  "GD_FORMAT_AC3_AUDIO_STREAMS_PARAM", "GD_FORMAT_MPEG_AUDIO_STEAMS", 
  "GD_FORMAT_DTS_AUDIO_STREAMS", "GD_FORMAT_LPCM_AUDIO_STREAMS", 
  "GD_FORMAT_MPEG_VIDEO_STERAMS", "GD_FORMAT_SPU_STERAMS", 
  "GD_MAP_AC3_AUDIO_STREAMS", "GD_MAP_MPEG_AUDIO_STREAMS", 
  "GD_MAP_DTS_AUDIO_STREAMS", "GD_MAP_LPCM_AUDIO_STREAMS", 
  "GD_MAP_MPEG_VIDEO_STREAMS", "GD_MAP_SPU_STREAMS", "STATE_CONSTRUCTED", 
  "STATE_INITIALIZED", "STATE_OUTPUT_INITIALIZED", "STATE_ACTIVATED", 
  "STATE_STARTED", "COMMENT", "TYPE_SHARED", "TYPE_EXCLUSIVE", 
  "TYPE_SHARED_OR_EXCLUSIVE", "TYPE_EXCLUSIVE_OR_SHARED", 
  "TYPE_EXCLUSIVE_THEN_SHARED", "TYPE_SHARED_OR_EXCLUSIVE_THEN_SHARED", 
  "TYPE_EXCLUSIVE_THEN_SHARED_OR_SHARED", "$accept", "flowgraph", "nil", 
  "start_subgraph", "description", "comment", "mux_jack", "demux_jack", 
  "branches", "int_list", "float_list", "connect_parameter", "connect", 
  "mux_connect", "subgraphes", "subgraph", "branch", "leftnode", 
  "rightnode", "sharing_type", "parameter", "node_parameter", 
  "config_parameter", "value", "state", "injack", "outjack", "nodename", 
  "format_string", "format_parameter", "format_value", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    78,    79,    80,    81,    82,    82,    83,    83,    84,
      84,    85,    85,    85,    86,    86,    87,    87,    88,    88,
      89,    89,    89,    89,    90,    91,    92,    92,    93,    93,
      93,    94,    94,    94,    94,    94,    94,    95,    96,    97,
      97,    97,    97,    97,    97,    97,    98,    98,    99,    99,
      99,    99,   100,   100,   100,   101,   101,   101,   101,   101,
     102,   102,   102,   102,   102,   103,   103,   104,   104,   105,
     106,   106,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   108
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     0,     1,     2,     1,     1,     1,     3,
       3,     3,     3,     1,     2,     1,     1,     3,     1,     3,
       1,     6,     6,     6,     2,     1,     2,     1,     5,     5,
       5,     3,     3,     5,     4,     3,     3,     4,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     6,
       6,     6,     1,     7,     6,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     0,     1,     1,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     3,     3,     5,     3,     5,     3,     3,
       3,     3,     3,     5,     3,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     3,     0,     6,     3,     5,     1,     7,     8,     3,
      66,     3,    15,     2,     3,     3,     0,     4,     3,    15,
      14,     0,    65,     3,    20,    65,    69,    67,     0,    27,
       0,     3,     0,    24,     0,    35,    32,     0,     3,    36,
      31,    68,     3,    13,     0,     3,    34,    26,     0,     0,
       0,     0,     0,    67,     0,    46,    37,     3,     0,     0,
      25,     3,     0,     0,     0,     9,    10,     3,    33,     0,
      52,    47,    11,    12,     0,     0,     3,     0,     0,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,     0,    72,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,     0,
      70,    38,     0,     0,     0,     0,    30,    29,    28,    22,
      23,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      21,     0,     0,     0,     0,     0,     0,    74,   157,    75,
      76,    77,    78,    79,     0,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    93,     0,    94,     0,
      96,     0,    98,    99,   100,   101,   102,     0,   104,     0,
      73,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    71,    39,    40,    41,    42,    43,
      45,    44,     0,     0,     0,     0,     3,    16,     0,    18,
       0,     0,     0,     0,     0,    51,    50,    49,     0,    59,
      58,    57,    55,     0,    80,     0,    92,     0,    95,    97,
     103,   105,    54,     0,     3,    17,    19,    60,    61,    62,
      63,    64,    53,    56
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,    24,    18,     4,     9,    35,    45,    13,   238,
     240,    21,    25,    61,    30,    31,    14,    15,    36,   232,
      56,    57,    71,   253,   272,    16,    42,    27,   119,   120,
     179
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -183
static const short yypact[] =
{
     -49,   -49,    30,  -183,    24,  -183,  -183,  -183,  -183,    -8,
    -183,  -183,  -183,  -183,    -8,    -7,    19,  -183,    59,     3,
    -183,     5,    22,  -183,  -183,    22,  -183,    25,    23,  -183,
      11,    59,   106,  -183,   -25,  -183,  -183,    19,    59,  -183,
    -183,  -183,  -183,  -183,   -11,  -183,  -183,  -183,    69,    86,
      87,    97,   102,    25,   107,     1,  -183,    95,   124,   126,
    -183,   -18,   128,   134,    63,  -183,  -183,  -183,  -183,   147,
    -183,   149,  -183,  -183,   132,   133,    29,   135,   136,   129,
     130,   131,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   148,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,  -183,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,    84,
    -183,  -183,   179,   180,   181,     2,  -183,  -183,  -183,  -183,
    -183,   188,   187,   187,   190,   191,   -26,   187,   192,   187,
     187,   187,   187,   194,   195,   196,   197,    -1,     9,    10,
     199,   187,   200,   187,    12,    14,   187,   187,   201,   202,
     187,   203,   204,   205,   206,   207,   208,   209,   210,   211,
    -183,    63,    33,   212,   213,   214,   215,  -183,  -183,  -183,
    -183,  -183,  -183,  -183,   216,  -183,  -183,  -183,  -183,  -183,
    -183,  -183,  -183,  -183,  -183,  -183,  -183,   218,  -183,   216,
    -183,   216,  -183,  -183,  -183,  -183,  -183,   216,  -183,   216,
    -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,
    -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,
    -183,  -183,   217,   220,   221,   223,   121,  -183,    53,  -183,
     113,   116,   117,   120,   123,  -183,  -183,  -183,   222,  -183,
    -183,  -183,  -183,    98,  -183,   216,  -183,   218,  -183,  -183,
    -183,  -183,  -183,    73,   121,   183,   219,  -183,  -183,  -183,
    -183,  -183,  -183,   224
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -183,  -183,     0,   227,   182,  -183,   -22,  -183,   -12,  -182,
     -75,  -183,    -4,  -183,    28,  -183,  -183,   225,   228,  -183,
     189,  -183,  -183,   -80,  -183,    -9,   226,   232,  -183,    26,
      -5
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -66
static const short yytable[] =
{
       3,     3,    20,    39,     8,   -48,   -20,   175,    32,    12,
      22,    17,   183,    37,    19,    51,    37,   241,    29,   242,
     184,     1,    10,    17,    11,   243,    52,   244,    34,    58,
       6,    29,    10,   -65,    11,    23,   195,   196,    29,    74,
      59,    60,    55,   -65,   -20,   197,    33,   198,   200,    75,
     206,   -48,   208,   176,    46,   199,   201,    70,   207,    47,
     209,    12,    10,    43,     7,    41,    54,    55,    34,    44,
      26,    23,   128,   265,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     254,    28,   255,   105,   225,   226,   227,   228,   229,   230,
     231,    48,    49,    62,    50,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   180,   170,
      63,    64,   185,   171,   187,   188,   189,   190,   267,   268,
     269,   270,   271,   263,    65,    69,   203,   264,   205,    66,
      68,   210,   211,   125,   122,   214,   123,   124,   249,   250,
     256,   251,   257,   258,   259,   255,   255,   260,    77,   255,
     261,    72,   255,    73,    78,   126,   127,   131,   132,   133,
     129,   130,   266,     5,   273,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,     0,   144,   224,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   172,   173,   174,   177,   178,   181,   182,
     186,   191,   255,   192,   193,   194,   252,   202,   204,   212,
     213,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      38,   234,   233,    40,   237,   239,   121,     0,   235,   236,
       0,     0,   245,   248,   252,   246,   247,   262,   257,    53,
       0,     0,     0,   264,     0,     0,     0,     0,     0,    67,
       0,     0,     0,     0,     0,     0,    76
};

static const short yycheck[] =
{
       0,     1,    14,    25,     4,     4,     3,     5,     3,     9,
      14,    11,    38,    22,    14,    40,    25,   199,    18,   201,
      46,    70,    40,    23,    42,   207,    51,   209,    46,    40,
       0,    31,    40,    51,    42,    42,    37,    38,    38,    61,
      51,    45,    42,    51,    41,    46,    41,    38,    38,    61,
      38,    50,    38,    51,    43,    46,    46,    57,    46,    31,
      46,    61,    40,    40,    40,    40,    38,    67,    46,    46,
      51,    42,    43,   255,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      47,    42,    49,    40,    71,    72,    73,    74,    75,    76,
      77,     5,     6,    44,     8,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,   133,    45,
      44,    44,   137,    49,   139,   140,   141,   142,    65,    66,
      67,    68,    69,    45,    47,    50,   151,    49,   153,    47,
      43,   156,   157,     4,     7,   160,     9,    10,    37,    38,
      47,    40,    49,    47,    47,    49,    49,    47,    40,    49,
      47,    47,    49,    47,    40,    43,    43,    48,    48,    48,
      45,    45,   257,     1,   264,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    -1,    48,   171,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    44,    44,    44,    38,    40,    38,    38,
      38,    37,    49,    38,    38,    38,   236,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      23,    38,    40,    25,    38,    37,    67,    -1,    44,    44,
      -1,    -1,    45,    40,   264,    45,    45,    45,    49,    37,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    -1,    61
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    70,    79,    80,    82,    82,     0,    40,    80,    83,
      40,    42,    80,    86,    94,    95,   103,    80,    81,    80,
      86,    89,    90,    42,    80,    90,    51,   105,    42,    80,
      92,    93,     3,    41,    46,    84,    96,   103,    81,    84,
      96,    40,   104,    40,    46,    85,    43,    92,     5,     6,
       8,    40,    51,   105,    92,    80,    98,    99,    40,    51,
      90,    91,    44,    44,    44,    47,    47,   104,    43,    50,
      80,   100,    47,    47,    84,    86,    95,    40,    40,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    40,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,   106,
     107,    98,     7,     9,    10,     4,    43,    43,    43,    45,
      45,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      45,    49,    44,    44,    44,     5,    51,    38,    40,   108,
     108,    38,    38,    38,    46,   108,    38,   108,   108,   108,
     108,    37,    38,    38,    38,    37,    38,    46,    38,    46,
      38,    46,    38,   108,    38,   108,    38,    46,    38,    46,
     108,   108,    38,    38,   108,    38,    38,    38,    38,    38,
      38,    38,    38,    38,   107,    71,    72,    73,    74,    75,
      76,    77,    97,    40,    38,    44,    44,    38,    87,    37,
      88,    87,    87,    87,    87,    45,    45,    45,    40,    37,
      38,    40,    80,   101,    47,    49,    47,    49,    47,    47,
      47,    47,    45,    45,    49,    87,    88,    65,    66,    67,
      68,    69,   102,   101
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 101 "GraphDescriptionParser.ypp"
    {
     nd_queue = queue<NodeDescription*>();
     nd_list = list<NodeDescription*>();
     start_branch_queue = queue<NodeDescription*>();
     end_branch_list = list< MuxConnection >();
     nd_list = list<NodeDescription*>();
     left_nd = NULL;
     left_intag ="";
     left_outtag = "";
     right_nd = NULL;
     right_intag = "";
     right_outtag = "";
     format = NULL;
     c_strategy_buffer = "";
     c_strategy_event  = "";
     n_strategy = "";
     __current_host = "";
     sharing_type = NodeDescription::EXCLUSIVE_OR_SHARED;
     __current_node_configuration = NodeConfiguration();
     __demuxer_format_stack = queue< DemuxConnection >();
     __starting_subgraph_list = list<RootNode>();
     __demuxer_list = list<NodeDescription*>();          
     __demux_connection = list<DemuxConnection>();
     starting_subgraph = true;
     store_first_leftnode = true;
     connect_muxer_nodes = false;
  }
    break;

  case 4:
#line 134 "GraphDescriptionParser.ypp"
    {
   /* Set starting_subgraph to init a new subgraph */
   starting_subgraph = true;
   
   /* Check wether MuxConnection is empty or not */
   if ( ! end_branch_list.empty() ) {
     //cerr << "WARNING ENDBRANCH_QUEUE NOT EMPTY!!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;
   }
 }
    break;

  case 5:
#line 147 "GraphDescriptionParser.ypp"
    {
  }
    break;

  case 7:
#line 154 "GraphDescriptionParser.ypp"
    {
   g->setComment(string(yyvsp[0]));
  }
    break;

  case 9:
#line 164 "GraphDescriptionParser.ypp"
    {
     string s(yyvsp[-1]);
     string s2 = s.substr(1, s.size() - 2);
     __set(yyval, s2);
  }
    break;

  case 10:
#line 171 "GraphDescriptionParser.ypp"
    {
     __set(yyval, string(yyvsp[-1]));
  }
    break;

  case 11:
#line 178 "GraphDescriptionParser.ypp"
    {
     string s(yyvsp[0]);
     string s2 = s.substr(1, s.size() - 2);
     __set(yyval, s2);
  }
    break;

  case 12:
#line 185 "GraphDescriptionParser.ypp"
    {
     __set(yyval, string(yyvsp[-1]));
  }
    break;

  case 13:
#line 190 "GraphDescriptionParser.ypp"
    {
     string s(yyvsp[0]);
     string s2 = s.substr(1, s.size() - 2);
     __set(yyval, s2);
  }
    break;

  case 14:
#line 199 "GraphDescriptionParser.ypp"
    {
     //cerr << "!!!!!!!!!! branches -> branch branches !!!!!!!!!1" << endl;
  }
    break;

  case 16:
#line 207 "GraphDescriptionParser.ypp"
    {
   i_list.push_back(atoi(yyvsp[0]));
  }
    break;

  case 17:
#line 211 "GraphDescriptionParser.ypp"
    {
  }
    break;

  case 18:
#line 216 "GraphDescriptionParser.ypp"
    {
   f_list.push_back(atof(yyvsp[0]));
  }
    break;

  case 19:
#line 220 "GraphDescriptionParser.ypp"
    {
  }
    break;

  case 21:
#line 228 "GraphDescriptionParser.ypp"
    {

  }
    break;

  case 22:
#line 233 "GraphDescriptionParser.ypp"
    {
    string s(yyvsp[-1]);
    c_strategy_event  = s.substr(1, s.size() - 2);
  }
    break;

  case 23:
#line 239 "GraphDescriptionParser.ypp"
    {
    string s(yyvsp[-1]);
    c_strategy_buffer = s.substr(1, s.size() - 2);
  }
    break;

  case 24:
#line 247 "GraphDescriptionParser.ypp"
    {
  }
    break;

  case 25:
#line 252 "GraphDescriptionParser.ypp"
    {
    /* if starting_subgraph is true, we start a new sub_graph.  
     * Either left_nd is demuxer or one of it's output jack is connected to more than one node
     */
    if ( starting_subgraph ) {
      //cerr << "Starting new subgraph! Demuxer Node is " << left_nd->getNodeName() << endl;
      __demuxer_list.push_front(left_nd);
      starting_subgraph = false;
    }

    /* Begin> Store all connection informaion */   
    DemuxConnection demux;
    demux.nd = __demuxer_list.front();
    demux.format = format;
    if (format) {
      cerr << "Demux Connection with format specification!!!!!!!!!!" << endl;
    }
    demux.c_strategy_buffer = c_strategy_buffer;
    demux.c_strategy_event  = c_strategy_event;
    __demux_connection.push_front( demux );
    /* End< */
    
    /* A new branch starts here and we have to store this NodeDescription to connect it later on to the demuxer */
    store_first_leftnode = true;

    /* At this point, the first node of a new subgraph must be connected to the demuxer */
    //cerr << "@@@@@@@@@@@@@@@ Invoke mux connect to connect a demuxer @@@@@@@@@@@@@@@@@@@@ " << endl;
    format = 0;
    c_strategy_buffer = "";
    c_strategy_event = "";
  }
    break;

  case 26:
#line 287 "GraphDescriptionParser.ypp"
    {
    //cerr << " =========================== Subgraphes -> Subgraph Subgraphes " << endl;
  }
    break;

  case 28:
#line 296 "GraphDescriptionParser.ypp"
    {  // e.g. { "default" ! SinkNode }
     
     /* If we don't have a demuxer, this is an invalid graph*/
     if ( __demux_connection.empty()  ) {
       cerr << "Invalid graph !!! " << endl;
       exit(0);
     }

     /* Add edge */
     size_t edge_id = g->addEdge(*__demux_connection.front().nd, string(yyvsp[-3]) , *left_nd, left_intag , __demux_connection.front().format);
     //cerr << " Subgraph: demux_jack mux_connect leftnode -> addEdge " << __demux_connection.front().nd->getNodeName() << "   " <<  string($2) << " -> " << left_nd->getNodeName() << "  " << left_intag << endl;

     /* Begin> Add the remaining connection parameters */      
     EdgeDescription& edge = g->getEdge(edge_id);
     //cerr << "Use Buffer Strategy " << c_strategy_buffer << endl;     
     if(!__demux_connection.front().c_strategy_buffer.empty()) {
       //cerr << "Use Buffer Strategy " << c_strategy_buffer << endl;
       edge.getBindingDescription().addTransportStrategy(__demux_connection.front().c_strategy_buffer, InstreamChannel::DOWNSTREAM_BUFFER);
     }
     if(!__demux_connection.front().c_strategy_event.empty()) {
       edge.getBindingDescription().addTransportStrategy(__demux_connection.front().c_strategy_event, InstreamChannel::INSTREAM_CEVENT);
     }
     /* End< */
     
     c_strategy_buffer = "";
     c_strategy_event  = "";
          
    delete format;
    format = 0;
    __starting_subgraph_list.pop_front();
    __demux_connection.pop_front();
     
  }
    break;

  case 29:
#line 331 "GraphDescriptionParser.ypp"
    {
    //cerr << " ----- OBRACE demux_jack mux_connect branch EBRACE ----- " << endl;  
    // e.g. { "default" ! MyNode ! .. ! SinkNode }

    /* If we don't have a demuxer, this is an invalid graph*/
    if ( __demux_connection.empty()  ) {
      cerr << "Invalid graph !!! " << endl;
      exit(0);
    } 
    
    /* If we don't have a node that starts the subgraph, this is an invalid graph*/
    if ( __starting_subgraph_list.empty() ) {
      cerr << "Invalid graph !!! " << endl;
      exit(0);    
    }

    /* Add edge */
    size_t edge_id = g->addEdge(*__demux_connection.front().nd, string(yyvsp[-3]) , *__starting_subgraph_list.front().second, __starting_subgraph_list.front().first , __demux_connection.front().format);
    
  //  cerr << " Subgraph: demux_jack mux_connect leftnode -> addEdge " << __demux_connection.front().nd->getNodeName() << "   " <<  string($2) << " -> " << __starting_subgraph_list.front().second->getNodeName() << "  " << __starting_subgraph_list.front().first << endl;
    
    if (__demux_connection.front().format) {
//      cerr << "Specify connection format " << endl << *__demux_connection.front().format << endl;
    }

        
    /* Begin> Add the remaining connection parameters */      
    EdgeDescription& edge = g->getEdge(edge_id);
    if(!__demux_connection.front().c_strategy_buffer.empty()) {
      edge.getBindingDescription().addTransportStrategy(__demux_connection.front().c_strategy_buffer, InstreamChannel::DOWNSTREAM_BUFFER);
    }
    if(!__demux_connection.front().c_strategy_event.empty()) {
      edge.getBindingDescription().addTransportStrategy(__demux_connection.front().c_strategy_event, InstreamChannel::INSTREAM_CEVENT);
    }
    /* End< */
    
    c_strategy_buffer = "";
    c_strategy_event  = "";
    
    // remove the starting node from our list
    __starting_subgraph_list.pop_front();
    // remove the connect inftomation from our list    
    __demux_connection.pop_front();
  }
    break;

  case 30:
#line 377 "GraphDescriptionParser.ypp"
    {
    /* If we don't have a demuxer, this is an invalid graph*/
    if ( __demux_connection.empty()  ) {
      cerr << "Invalid graph !!! " << endl;
      exit(0);
    } 

    if (format) {
      end_branch_list.push_front(MuxConnection(__demux_connection.front().nd, (yyvsp[-3]), (yyvsp[-1]), new Format(*format)));
      delete format;
      format = 0;
    }
    else
      end_branch_list.push_front(MuxConnection(__demux_connection.front().nd, (yyvsp[-3]), (yyvsp[-1])));
      
    //cerr << "<<<<<<<<<<<< Must connect " << __demux_connection.front().nd->getNodeName() <<  " : " << string($4) << endl;
  }
    break;

  case 31:
#line 401 "GraphDescriptionParser.ypp"
    {
    size_t edge_id = g->addEdge(*left_nd, left_outtag, *right_nd, right_intag, format);
    //cerr << " branch leftnode connect rightnode: addEdge " << left_nd->getNodeName() << "   " <<  left_outtag << " -> " << right_nd->getNodeName() << " " << right_intag << endl;
    EdgeDescription& edge = g->getEdge(edge_id);
    if(!c_strategy_buffer.empty()) {
      edge.getBindingDescription().addTransportStrategy(c_strategy_buffer, InstreamChannel::DOWNSTREAM_BUFFER);
    }
    if(!c_strategy_event.empty()) {
      edge.getBindingDescription().addTransportStrategy(c_strategy_event, InstreamChannel::INSTREAM_CEVENT);
    }
    left_nd = right_nd;
    left_outtag = right_outtag;
    left_intag  = right_intag;

    /* Begin> reset the global variables */
    delete format;
    format = 0;
    c_strategy_buffer = "";
    c_strategy_event = "";
    /* End< */
  }
    break;

  case 32:
#line 424 "GraphDescriptionParser.ypp"
    {
    size_t edge_id = g->addEdge(*left_nd, left_outtag, *right_nd, right_intag, format);
    //cerr << " branch connect rightnode: addEdge " << left_nd->getNodeName() << "   " <<  left_outtag << " -> " << right_nd->getNodeName() << " " << right_intag << endl;
    EdgeDescription& edge = g->getEdge(edge_id);
    if(!c_strategy_buffer.empty()) {
      edge.getBindingDescription().addTransportStrategy(c_strategy_buffer, InstreamChannel::DOWNSTREAM_BUFFER);
    }
    if(!c_strategy_event.empty()) {
      edge.getBindingDescription().addTransportStrategy(c_strategy_event, InstreamChannel::INSTREAM_CEVENT);
    }
    left_nd = right_nd;
    left_outtag = right_outtag;
    left_intag  = right_intag;

    /* Begin> reset the global variables */
    delete format;
    format = 0;
    c_strategy_buffer = "";
    c_strategy_event = "";
    /* End< */
  }
    break;

  case 33:
#line 447 "GraphDescriptionParser.ypp"
    {
    //cerr << "Close subgraph 1" << endl;
    GLOBAL_DEBUG_STREAM( "close Subgraph" << endl);
    if (__demuxer_list.empty() ) {
      cerr << "Invalid graph" << endl;
      exit(0);
    } 
    //cerr << "Remove Demuxer " << __demuxer_list.front()->getNodeName() << endl;
    __demuxer_list.pop_front();
    if ( !end_branch_list.empty() ) {
      connect_muxer_nodes = true;
    }
  }
    break;

  case 34:
#line 462 "GraphDescriptionParser.ypp"
    {
    //cerr << "Close subgraph 2" << endl;
    GLOBAL_DEBUG_STREAM( "close Subgraph" << endl);
    if (__demuxer_list.empty() ) {
      cerr << "Invalid graph" << endl;
      exit(0);
    } 
    //cerr << "Remove Demuxer " << __demuxer_list.front()->getNodeName() << endl;
    __demuxer_list.pop_front();
    if ( !end_branch_list.empty() ) {
      connect_muxer_nodes = true;
    }
  }
    break;

  case 35:
#line 477 "GraphDescriptionParser.ypp"
    {
    if (format) {
      end_branch_list.push_front(MuxConnection(left_nd, left_outtag, (yyvsp[0]), new Format(*format)));
      delete format;
      format = 0;
    }
    else
      end_branch_list.push_front(MuxConnection(left_nd, left_outtag, (yyvsp[0])));
    
    //cerr << "Must connect " << left_nd->getNodeName() <<  " : " << left_outtag << endl;
  }
    break;

  case 36:
#line 490 "GraphDescriptionParser.ypp"
    {
    if (format) {
      end_branch_list.push_front(MuxConnection(left_nd, left_outtag, (yyvsp[0]), new Format(*format)));
      delete format;
      format = 0;
    }
    else
      end_branch_list.push_front(MuxConnection(left_nd, left_outtag, (yyvsp[0])));
  }
    break;

  case 37:
#line 503 "GraphDescriptionParser.ypp"
    {
    //cerr << "leftnode -> " << string ($2) << endl;
    left_intag = string(yyvsp[-3]);      // store the new left_intag
    /* If the left_nd was not reset to 0, the left_nd is a Demux which connects to a subgraph
     * and must be stored in queue.
     */                                                   
    if (left_nd) {
      //cerr << "left_nd push to nd_queue " << left_nd->getNodeName() << endl;
      nd_queue.push(left_nd);
      //cerr << "left_nd push to nd_list " << left_nd->getNodeName() << endl;
      nd_list.push_front(left_nd);
 
      left_nd = new NodeDescription(string(yyvsp[-2]));
      left_outtag = string(yyvsp[-1]);
      start_branch_queue.push(left_nd);
    } else {
      //cerr << "left_nd = 0 " << endl;
      left_nd = new NodeDescription(string(yyvsp[-2]));
      left_outtag = string(yyvsp[-1]);
    }
    left_nd->setTransportStrategy( n_strategy );

    /* if store_first_leftnode is true, left_nd is the first node of a (sub)graph */
    if ( store_first_leftnode ) {
       //cerr << "STORE FIRST LEFT NODE " << left_nd->getNodeName() << endl;
       __starting_subgraph_list.push_front(RootNode(left_intag, left_nd));
       store_first_leftnode = false;
    }
    
    /* store the current node configuration in the current NodeConfiguration object*/
    __current_node_configuration.setNodeDescription(left_nd);
    /* add the current NodeConfiguration object to the list*/
    GDParse::node_configuration.push_back(__current_node_configuration);
    /* clear the current settings, so that the object can be reused */
    __current_node_configuration.clear();

    n_strategy = "";

    /* Begin> Set the location if available*/
    if (!__current_host.empty()) {
      left_nd->setLocation(__current_host);
      left_nd->setPort(__current_port);
      __current_host = string();
      __current_port = ClientRegistry::default_port;
    }
    /* End< */

    /* Set the sharing Type*/
    left_nd->setSharingType(sharing_type);

    /* Check if left_nd is a Multiplexer */ 
    if ( connect_muxer_nodes ) {
      //cerr << " %%%%%%%%%%%%%%% " << left_nd->getNodeName() << " is a Multiplexer " << endl;
        while(!end_branch_list.empty()) {
          /* Connect the stored MuxConnection to the MuxNode */
          //cerr <<  "connect " << end_branch_list.front().nd->getNodeName() << " : " << end_branch_list.front().out_tag << " with " << left_nd->getNodeName() << " : " << end_branch_list.front().mux_in_tag  << endl;
          
	  //Add the edge 
	  size_t edge_id = g->addEdge(*end_branch_list.front().nd, end_branch_list.front().out_tag, *left_nd, end_branch_list.front().mux_in_tag, end_branch_list.front().format);
          
	  //Set edge specific parameters 
	  EdgeDescription& edge = g->getEdge(edge_id);
          if(!end_branch_list.front().c_strategy_buffer.empty()) {
            edge.getBindingDescription().addTransportStrategy(end_branch_list.front().c_strategy_buffer, InstreamChannel::DOWNSTREAM_BUFFER);
          }
          if(!end_branch_list.front().c_strategy_event.empty()) {
            edge.getBindingDescription().addTransportStrategy(end_branch_list.front().c_strategy_event, InstreamChannel::INSTREAM_CEVENT);
          }	  
          end_branch_list.pop_front();
       }
       connect_muxer_nodes = false;
     } 

    /* reset the sharing type */
    sharing_type = NodeDescription::EXCLUSIVE_OR_SHARED;
    
    GLOBAL_DEBUG_STREAM("left_nd = new NodeDescription(\"" << string(yyvsp[-2]) << "\");" << endl);
  }
    break;

  case 38:
#line 585 "GraphDescriptionParser.ypp"
    { 
    //cerr << "rightnode -> " << string ($2) << endl;
    right_intag = string(yyvsp[-3]);
    right_nd = new NodeDescription(string(yyvsp[-2]));
    right_outtag = string(yyvsp[-1]);
    right_nd->setTransportStrategy(n_strategy);
    /* store the current node configuration in the current NodeConfiguration object*/
    __current_node_configuration.setNodeDescription(right_nd);
    /* add the current NodeConfiguration object to the list*/
    GDParse::node_configuration.push_back(__current_node_configuration);
    /* clear the current settings, so that the object can be reused */
    __current_node_configuration.clear();
    n_strategy = "";


    /* Begin> Set the location if available*/
    if (!__current_host.empty()) {
      right_nd->setLocation(__current_host);
      right_nd->setPort(__current_port);
      __current_host = string();
      __current_port = ClientRegistry::default_port;
    }
    /* End< */

    /* Set the sharing Type*/
    right_nd->setSharingType(sharing_type);

    /* reset the sharing type */
    sharing_type = NodeDescription::EXCLUSIVE_OR_SHARED;

    GLOBAL_DEBUG_STREAM("right_nd = new NodeDescription(\"" << string(yyvsp[-2]) << "\");" << endl);
  }
    break;

  case 39:
#line 619 "GraphDescriptionParser.ypp"
    {
    sharing_type = NodeDescription::SHARED;
  }
    break;

  case 40:
#line 623 "GraphDescriptionParser.ypp"
    {
    sharing_type = NodeDescription::EXCLUSIVE;
  }
    break;

  case 41:
#line 627 "GraphDescriptionParser.ypp"
    {
    sharing_type = NodeDescription::SHARED_OR_EXCLUSIVE;
  }
    break;

  case 42:
#line 631 "GraphDescriptionParser.ypp"
    {
    sharing_type = NodeDescription::EXCLUSIVE_OR_SHARED;
  }
    break;

  case 43:
#line 635 "GraphDescriptionParser.ypp"
    {
    sharing_type = NodeDescription::EXCLUSIVE_THEN_SHARED;
  }
    break;

  case 44:
#line 639 "GraphDescriptionParser.ypp"
    {
    sharing_type = NodeDescription::EXCLUSIVE_THEN_SHARED_OR_SHARED;
  }
    break;

  case 45:
#line 643 "GraphDescriptionParser.ypp"
    {
    sharing_type = NodeDescription::SHARED_OR_EXCLUSIVE_THEN_SHARED;
  }
    break;

  case 47:
#line 652 "GraphDescriptionParser.ypp"
    {
  }
    break;

  case 49:
#line 660 "GraphDescriptionParser.ypp"
    {  
    __current_port = atoi(yyvsp[-1]);
  }
    break;

  case 50:
#line 665 "GraphDescriptionParser.ypp"
    {
    string s(yyvsp[-1]);
    string tmp_host = s.substr(1, s.size()-2);
    __current_host = tmp_host;
  }
    break;

  case 51:
#line 671 "GraphDescriptionParser.ypp"
    {

  }
    break;

  case 53:
#line 680 "GraphDescriptionParser.ypp"
    {
    if (! __current_nc_element )
      __current_nc_element = new NCElement();

    __current_nc_element->event_key = string(yyvsp[-4]);
    __current_node_configuration.addNCElement( *__current_nc_element );

    /* cleanup */
    delete __current_nc_element;
    __current_nc_element = 0;
  }
    break;

  case 54:
#line 692 "GraphDescriptionParser.ypp"
    {
    string s(yyvsp[-1]);
    n_strategy = s.substr(1, s.size()-2);
  }
    break;

  case 56:
#line 702 "GraphDescriptionParser.ypp"
    {
      
  }
    break;

  case 57:
#line 707 "GraphDescriptionParser.ypp"
    {
    if (!__current_nc_element)
      __current_nc_element = new NCElement();

    string s(yyvsp[0]);
    string tmp_string = s.substr(1, s.size() - 2);   
    __current_nc_element->argument_list.push_back(tmp_string);
  }
    break;

  case 58:
#line 717 "GraphDescriptionParser.ypp"
    {
    if (!__current_nc_element)
      __current_nc_element = new NCElement();
    
    __current_nc_element->argument_list.push_back(string(yyvsp[0]));
  }
    break;

  case 59:
#line 725 "GraphDescriptionParser.ypp"
    {
    if (!__current_nc_element)
      __current_nc_element = new NCElement();
      
    __current_nc_element->argument_list.push_back(string(yyvsp[0]));
  }
    break;

  case 60:
#line 737 "GraphDescriptionParser.ypp"
    {
    if (!__current_nc_element)
      __current_nc_element = new NCElement();

    __current_nc_element->state = INode::CONSTRUCTED;
  }
    break;

  case 61:
#line 745 "GraphDescriptionParser.ypp"
    {
    if (!__current_nc_element)
      __current_nc_element = new NCElement();
    __current_nc_element->state = INode::INITIALIZED;
  }
    break;

  case 62:
#line 752 "GraphDescriptionParser.ypp"
    {
    if (!__current_nc_element)
      __current_nc_element = new NCElement();
    __current_nc_element->state = INode::OUTPUT_INITIALIZED;
  }
    break;

  case 63:
#line 759 "GraphDescriptionParser.ypp"
    {
    if (!__current_nc_element)
      __current_nc_element = new NCElement();
    __current_nc_element->state = INode::ACTIVATED;
  }
    break;

  case 64:
#line 766 "GraphDescriptionParser.ypp"
    {
    if (!__current_nc_element)
      __current_nc_element = new NCElement();
    __current_nc_element->state = INode::STARTED;
  }
    break;

  case 65:
#line 774 "GraphDescriptionParser.ypp"
    {
    __set(yyval, "default");
  }
    break;

  case 66:
#line 779 "GraphDescriptionParser.ypp"
    {
    string s(yyvsp[0]);
    string s2 = s.substr(1, s.size() - 2);
    __set(yyval, s2);
  }
    break;

  case 67:
#line 787 "GraphDescriptionParser.ypp"
    {
    __set(yyval, "default");
  }
    break;

  case 68:
#line 792 "GraphDescriptionParser.ypp"
    {
    string s(yyvsp[0]);
    string s2 = s.substr(1, s.size() - 2);
    __set(yyval, s2);
  }
    break;

  case 69:
#line 801 "GraphDescriptionParser.ypp"
    {
  }
    break;

  case 70:
#line 806 "GraphDescriptionParser.ypp"
    {
  }
    break;

  case 71:
#line 809 "GraphDescriptionParser.ypp"
    {
  }
    break;

  case 72:
#line 813 "GraphDescriptionParser.ypp"
    {
    string s(yyvsp[0]);
    string s2 = s.substr(1, s.size() - 2);
    if (!format) {
      format = new Format();
    }
    format->setFormatType( s2 );
    //cerr << "Create new Format " << s << endl;
  }
    break;

  case 73:
#line 823 "GraphDescriptionParser.ypp"
    {
    if (!format) {
      format = new Format();
    }
    format->setFormatType(  (yyvsp[0]) );
  }
    break;

  case 74:
#line 830 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::audio_codec_param, atoi(yyvsp[0]) );
  }
    break;

  case 75:
#line 836 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::audio_format_param, (yyvsp[0]) );
  }
    break;

  case 76:
#line 842 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::audio_format_string_param, (yyvsp[0]) );
  }
    break;

  case 77:
#line 848 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::bitperpixel_param , atoi(yyvsp[0]) );
  }
    break;

  case 78:
#line 854 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::bitpersample_param, atoi(yyvsp[0]) );
  }
    break;

  case 79:
#line 860 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::bitrate_param, atoi(yyvsp[0]) );
  }
    break;

  case 80:
#line 866 "GraphDescriptionParser.ypp"
    {
    if (!format)
        format = new Format();
    for (list<int>::iterator iter=i_list.begin();iter!=i_list.end(); iter++) {
      format->addIntParamValue( Format::bitrate_param, (*iter));
    }
    i_list.clear();
  }
    break;

  case 81:
#line 875 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::channelorder_param, (yyvsp[0]) );
  }
    break;

  case 82:
#line 881 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::channels_param, atoi(yyvsp[0]) );
  }
    break;

  case 83:
#line 887 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::colorspace_param, (yyvsp[0]) );
  }
    break;

  case 84:
#line 893 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::compressor_param, (yyvsp[0]) );
  }
    break;

  case 85:
#line 899 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::encoding_param, (yyvsp[0]) );
  }
    break;

  case 86:
#line 905 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::endian_param, (yyvsp[0]) );
  }
    break;

  case 87:
#line 911 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addFloatParamValue( Format::framerate_param, atof(yyvsp[0]) );
  }
    break;

  case 88:
#line 917 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::layer_param, atoi(yyvsp[0]) );
  }
    break;

  case 89:
#line 923 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::num_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 90:
#line 929 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::num_video_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 91:
#line 935 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addFloatParamValue( Format::quality_param, atof(yyvsp[0]) );
  }
    break;

  case 92:
#line 941 "GraphDescriptionParser.ypp"
    {
    if (!format)
        format = new Format();
    for (list<float>::iterator iter=f_list.begin();iter!=f_list.end(); iter++) {
      format->addFloatParamValue( Format::quality_param, (*iter));
    }
    f_list.clear();
  }
    break;

  case 93:
#line 950 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::quality_param, atoi(yyvsp[0]) );
  }
    break;

  case 94:
#line 956 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::ratio_x_param, atoi(yyvsp[0]) );
  }
    break;

  case 95:
#line 962 "GraphDescriptionParser.ypp"
    {
    if (!format)
        format = new Format();
    for (list<int>::iterator iter=i_list.begin();iter!=i_list.end(); iter++) {
      format->addIntParamValue( Format::ratio_x_param, (*iter));
    }
    i_list.clear();
  }
    break;

  case 96:
#line 971 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::ratio_y_param, atoi(yyvsp[0]) );
  }
    break;

  case 97:
#line 977 "GraphDescriptionParser.ypp"
    {
    if (!format)
        format = new Format();
    for (list<int>::iterator iter=i_list.begin();iter!=i_list.end(); iter++) {
      format->addIntParamValue( Format::ratio_y_param, (*iter));
    }
    i_list.clear();
  }
    break;

  case 98:
#line 986 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::sample_rate_param, atoi(yyvsp[0]) );
  }
    break;

  case 99:
#line 992 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::sign_param, (yyvsp[0]) );
  }
    break;

  case 100:
#line 998 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::version_param, atoi(yyvsp[0]) );
  }
    break;

  case 101:
#line 1004 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::video_format_param, (yyvsp[0]) );
  }
    break;

  case 102:
#line 1010 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::x_resolution_param, atoi(yyvsp[0]) );
  }
    break;

  case 103:
#line 1016 "GraphDescriptionParser.ypp"
    {
    if (!format)
        format = new Format();
    for (list<int>::iterator iter=i_list.begin();iter!=i_list.end(); iter++) {
      format->addIntParamValue( Format::x_resolution_param, (*iter));
    }
    i_list.clear();
  }
    break;

  case 104:
#line 1025 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::y_resolution_param, atoi(yyvsp[0]) );
  }
    break;

  case 105:
#line 1031 "GraphDescriptionParser.ypp"
    {
    if (!format)
        format = new Format();
    for (list<int>::iterator iter=i_list.begin();iter!=i_list.end(); iter++) {
      format->addIntParamValue( Format::y_resolution_param, (*iter));
    }
    i_list.clear();
  }
    break;

  case 106:
#line 1040 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addStringParamValue( Format::format_param, (yyvsp[0]) );
  }
    break;

  case 107:
#line 1046 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::format_ac3_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 108:
#line 1052 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::format_mpeg_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 109:
#line 1058 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::format_dts_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 110:
#line 1064 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::format_lpcm_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 111:
#line 1070 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::format_mpeg_video_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 112:
#line 1076 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::format_spu_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 113:
#line 1082 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::map_ac3_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 114:
#line 1088 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::map_mpeg_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 115:
#line 1094 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::map_dts_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 116:
#line 1100 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::map_lpcm_audio_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 117:
#line 1106 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::map_mpeg_video_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 118:
#line 1112 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addIntParamValue( Format::map_spu_streams_param, atoi(yyvsp[0]) );
  }
    break;

  case 119:
#line 1118 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::audio_codec_param);
  }
    break;

  case 120:
#line 1124 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::audio_format_param );
  }
    break;

  case 121:
#line 1130 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::audio_format_string_param );
  }
    break;

  case 122:
#line 1136 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::bitperpixel_param );
  }
    break;

  case 123:
#line 1142 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::bitpersample_param);
  }
    break;

  case 124:
#line 1148 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::bitrate_param);
  }
    break;

  case 125:
#line 1154 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::channelorder_param );
  }
    break;

  case 126:
#line 1160 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::channels_param);
  }
    break;

  case 127:
#line 1166 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::colorspace_param );
  }
    break;

  case 128:
#line 1172 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::compressor_param );
  }
    break;

  case 129:
#line 1178 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::encoding_param );
  }
    break;

  case 130:
#line 1184 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::endian_param );
  }
    break;

  case 131:
#line 1190 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::framerate_param);
  }
    break;

  case 132:
#line 1196 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::layer_param);
  }
    break;

  case 133:
#line 1202 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::num_audio_streams_param );
  }
    break;

  case 134:
#line 1208 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::num_video_streams_param);
  }
    break;

  case 135:
#line 1214 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::quality_param );
  }
    break;

  case 136:
#line 1220 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::ratio_x_param);
  }
    break;

  case 137:
#line 1226 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::ratio_y_param);
  }
    break;

  case 138:
#line 1232 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::sample_rate_param);
  }
    break;

  case 139:
#line 1238 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::sign_param );
  }
    break;

  case 140:
#line 1244 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::version_param );
  }
    break;

  case 141:
#line 1250 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::video_format_param );
  }
    break;

  case 142:
#line 1256 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::x_resolution_param);
  }
    break;

  case 143:
#line 1262 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::y_resolution_param);
  }
    break;

  case 144:
#line 1268 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::format_param);
  }
    break;

  case 145:
#line 1274 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::format_ac3_audio_streams_param);
  }
    break;

  case 146:
#line 1280 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::format_mpeg_audio_streams_param);
  }
    break;

  case 147:
#line 1286 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::format_dts_audio_streams_param);
  }
    break;

  case 148:
#line 1292 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::format_lpcm_audio_streams_param);
  }
    break;

  case 149:
#line 1298 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::format_mpeg_video_streams_param);
  }
    break;

  case 150:
#line 1304 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::format_spu_streams_param);
  }
    break;

  case 151:
#line 1310 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::map_ac3_audio_streams_param);
  }
    break;

  case 152:
#line 1316 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::map_mpeg_audio_streams_param);
  }
    break;

  case 153:
#line 1322 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::map_dts_audio_streams_param);
  }
    break;

  case 154:
#line 1328 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::map_lpcm_audio_streams_param);
  }
    break;

  case 155:
#line 1334 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::map_mpeg_video_streams_param);
  }
    break;

  case 156:
#line 1340 "GraphDescriptionParser.ypp"
    {
    if (!format)
      format = new Format();
    format->addWildcard( Format::map_spu_streams_param);
  }
    break;

  case 157:
#line 1349 "GraphDescriptionParser.ypp"
    {
  string s(yyvsp[0]);
  string s2 = s.substr(1, s.size() - 2);
  __set(yyval, s2);
}
    break;


    }

/* Line 991 of yacc.c.  */
#line 3052 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



