% This graph description reads an MP3 file from the remote
% and plays it synchronously on both the local host and a remote host
% using the ALSAPlaybackNode.
% Both hosts must be running Linux.

% You must edit the line containing setLocation(...) and enter the name of the remote host

% Command on remote host:
%   serverregistry

% Command on local host:
%   clic mp3play_dist.gd -i <remote MP3 file>

  MP3ReadNode                         # setLocation("foo")
{
  { ["default"] ! MPEGAudioDecodeNode # setLocation("foo")
                ! ALSAPlaybackNode    # setLocation("foo")
  }
  { ["default"] ! MPEGAudioDecodeNode
                ! ALSAPlaybackNode
  }
}
