% This graph description plays an AVI file with MPEG audio and DIVX video
% using the ALSAPlaybackNode and the XDisplayNode. It furthermore displays 
% an overlay of the current system time using the TimeDisplayNode.
% It can only be run on Linux.

% Command:
%   clic aviplay_with_time.gd -i <local AVI file>

  AVIReadNode
! AVDemuxNode
{
  { ["video"] ! FFMpegDecodeNode
              ! YUVtoRGBConverterNode
              ! TimeDisplayNode $setOffset(10, 10) INITIALIZED
              ! XDisplayNode
  }
  { ["audio"] ! MPEGAudioDecodeNode
              ! ALSAPlaybackNode
  }
}

