/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


// No inclusion guard here (intentional)

// NOTE: No need to include "config.h"
#ifdef BUILD_WINXP

// Push warning state
#pragma warning(push)

// Disable warnings
// NOTE: Only add warnings here if they can not be avoided!
#pragma warning(disable:4290)   // warning C4290: C++ exception specification ignored except to indicate a function is not __declspec(nothrow)
#pragma warning(disable:4251)   // 'Class::member' : class 'Template<...>' needs to have dll-interface to be used by clients of class 'Class'
#pragma warning(disable:4275)   // non dll-interface class 'Base' used as base for dll-interface class 'Derived'
#pragma warning(disable:4250)   // 'Derived' : inherits 'Base::Base::method' via dominance

#endif
